/* This file is part of The_Merry_Turnip
 * 
 * The_Merry_Turnip - TODO: Description
 * Copyright © DAVY Guillaume 2009 <davyg2@gmail.com>
 * 
 * The_Merry_Turnip is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * The_Merry_Turnip is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*!	\file base.h
	\brief Definition of base class 
*/

#ifndef __BASE_H_INCLUDED__
#define __BASE_H_INCLUDED__

//!Class from whom most of the other class derive from, derive from IEventReceiver
class base : public IEventReceiver
{
public:
	//! Constructor
	base(stringc=stringc("base"));
	
	//! Destructor
	~base();
	
	//! Init the base
	virtual int init(int,coeur*);
	
	//! Updating(should be call on each loop)
	virtual int update();
	
	//! Close the base
	virtual int close();
	
	//! Return the base::id
	int getId();
	
	//! Log some text
	int log(stringc);
	
	//! return base::initialize
	bool isInit();

protected:
	//! Pointer to the core
	coeur* mycore;

private:
	//! Id of the class
	int id;
	
	//! Name of the class
	stringc nameClass;
	
	//! Id of the log
	int logId;
	
	//! Contain True if base initialized
	bool initialize;
};// End class base

#endif //__BASE_H_INCLUDED__

