/* This file is part of The_Merry_Turnip
 * 
 * The_Merry_Turnip - TODO: Description
 * Copyright © DAVY Guillaume 2009 <davyg2@gmail.com>
 * 
 * The_Merry_Turnip is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * The_Merry_Turnip is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*!	\file console.h
	\brief Definition of class console
*/

#ifndef __CONSOLE_H_INCLUDED__
#define __CONSOLE_H_INCLUDED__

//!This class handle all the suff of the console
class console : public base
{
public:
	//! Constructor
	console();
	
	//! Destructor
	~console();
	
	//! Init the console
	int init(coeur *,IGUIEnvironment *);
	
	//! Updating (must be call on each loop)
	int update();
	
	//! Close the console
	int close();
	
	//! Call when an event occured
	bool OnEvent(const SEvent&);
	
	//! Write some text on the console
	void write(std::string const&);
	
	//! Display the position of the camera
	void position();
	
	//! Display the rotation of the camera
	void rotation();
	
	//! Display the position of the target of the camera
	void target();
	
	//! Close the console
	//! /todo Change the name of this function because it exit as much as it lake visible
	void exit();
	
	//! Quit the game
	void quit();
	
	//! Display an helping text
	void help();
	
	//! Display the actual fps
	void fps();
		
private:
	//! The Irrlicht Device
	IrrlichtDevice *device;
	
	//! The Irrlicht Envirronement
	IGUIEnvironment* env;

	//! Contain the text display by the console
	stringw *text;
	
	//! Just use to contain all the item of the console
	IGUIImage *cons;
	
	//! Box where are displayed the text of the console
	IGUIEditBox *tx;
	
	//! Box where you type the command to launch to the console
	IGUIEditBox* box;
	
	//! Box who displayed the fps
	IGUIStaticText* FPS;
	
	//! Contain the history of the command enter
	std::vector<stringw>* history;
	
	//! Contain the position in the history
	unsigned int histPos;
};

#endif //__CONSOLE_H_INCLUDED__

