#include <game.h>

//! /todo refaire inventaire pour mettre un nombre infini d'item
//! /todo Afficher inventaire en fonction taille(redimensionner)
//! /todo Check sound really launched
//! /todo Load the texture at the beginning in order not to slow down the game

interface::interface() : base("interface")
{
	inv = new std::vector<inventaire*>;
}

interface::~interface()
{
	delete inv;
}

int interface::init(coeur *c,IGUIEnvironment *e,IXMLReader* xmlInterface,bool cl)
{
	base::init(0,c);
	env = e;
	
	classic=cl;
	
	log(stringc("Interface xml loading ..."));
	
	while(xmlInterface && xmlInterface->read())
	{
		if (xmlInterface->getNodeType()==EXN_ELEMENT)
		{
			if (core::stringw("interface") == xmlInterface->getNodeName())
				inv->reserve(xmlInterface->getAttributeValueAsInt(L"nbrinv"));
			else if (core::stringw("inventaire") == xmlInterface->getNodeName())
			{
				addInventaire(xmlInterface->getAttributeValueAsInt(L"id"),xmlInterface->getAttributeValue(L"image"),xmlInterface->getAttributeValueAsInt(L"v"),INVENTAIRE_POS(xmlInterface->getAttributeValueAsInt(L"pos")),stringc(xmlInterface->getAttributeValue(L"void")));
				log( stringc("Add inventaire : id:") + xmlInterface->getAttributeValue(L"v") + ", image:\"" + xmlInterface->getAttributeValue(L"image") + "\", v:" + xmlInterface->getAttributeValue(L"v") + ", Pos:" + xmlInterface->getAttributeValue(L"pos"));
					
			}
			else if (core::stringw("cursor") == xmlInterface->getNodeName())
			{
				curDefault = stringc(xmlInterface->getAttributeValue(L"default"));
				curTake = stringc(xmlInterface->getAttributeValue(L"take"));
				curLook = stringc(xmlInterface->getAttributeValue(L"look"));
				curAction = stringc(xmlInterface->getAttributeValue(L"action"));
				log( stringc("Load cursor image : default:\"") + xmlInterface->getAttributeValue(L"default") + ", take:\"" + xmlInterface->getAttributeValue(L"take") + ", look:\"" + xmlInterface->getAttributeValue(L"look") + ", action:\"" + xmlInterface->getAttributeValue(L"action") + "\"");
			}
			else if (core::stringw("font") == xmlInterface->getNodeName())
			{
				//TODO: Problem with the path of the font in the xml. (getFont take a real path)
				mainFont = env->getFont(stringc(xmlInterface->getAttributeValue(L"main")).c_str());
				log( stringc("Load font : main:\"") + xmlInterface->getAttributeValue(L"main") + "\"");
			}
			else if (core::stringw("sound") == xmlInterface->getNodeName())
			{
				soundFind = stringc(xmlInterface->getAttributeValue(L"find")).c_str();
				log( stringc("Load sound : find:\"") + xmlInterface->getAttributeValue(L"find") + "\"");
			}
		}
	}

	env->getSkin()->setFont(mainFont);
	log("Main font put on");
	if (classic)
	{
		image = env->addImage(mycore->getTexture(curDefault),position2d<s32>(0,0));
	}
	else
	{
		psCur = mycore->addParticleSystem();
		psCur->setParticleSize(dimension2d<f32>(2.0f, 2.0f));
	
		emCur = psCur->createPointEmitter (
			vector3df(0,0,0.01),
			200, 200,
			SColor(255, 255, 255, 255), SColor(255, 255, 255, 255),
			500,1000,
			0,
			dimension2df(2.0f, 2.0f),dimension2df(2.0f, 2.0f)
		);
		psCur->setEmitter(emCur);
		emCur->drop();
		
		pafCur = psCur->createAttractionAffector (vector3df(0,0,0),150);
		psCur->addAffector(pafCur);
		pafCur->drop();
		psCur->setMaterialFlag(EMF_LIGHTING, false);
		psCur->setMaterialTexture(0, mycore->getTexture("texture/particle.png"));
		psCur->setMaterialType(EMT_TRANSPARENT_ALPHA_CHANNEL);
	}
	
	log("Cursor image added");
	txt = env->addStaticText(L"",rect<s32>(200,c->getDim().Height-140,c->getDim().Width-200,c->getDim().Height-100));
	txt->setTextAlignment(EGUIA_CENTER,EGUIA_CENTER);
	log("Txt added");
	
	handle=item();
	selectedInv = -1;
	selectedItem = -1;
	pselectedInv = -1;
	pselectedItem = -1;
	
	afficherInventaire(false);
	log("hide the inventaire");
	
	return 1;
}

int interface::update()
{
	if ( (mycore->getCurPos().X<100)||
			(mycore->getCurPos().Y<100)||
			(mycore->getCurPos().X > mycore->getDim().Width-100)||
			(mycore->getCurPos().Y > mycore->getDim().Height-100)){
			afficherInventaire(true);
		}else
		{
			afficherInventaire(false);
		}
	for (unsigned int i=0;i<inv->size();i++)
		inv->at(i)->update();
	env->getRootGUIElement()->bringToFront(image);
	
	selectedInv = -1;
	selectedItem = -1;
	for (unsigned int i=0;i<inv->size();i++)
	{
		if ( inv->at(i)->getImage()->isPointInside( mycore->getCurPos() ) )
		{
			selectedInv = i;
			selectedItem = inv->at(selectedInv)->getNumItem(mycore->getCurPos());
			break;
		}
	}
	
	if (classic)
	{
		setImagePosition(mycore->getCurPos()-position2d<s32>(20,20));
		setImage(curDefault);
		if ( (mycore->getSelectedAction()) && !v)
		{
			if (mycore->getSelectedAction()->getAction()==ACTION_OBSERVER)
				setImage(curLook);
			else if (mycore->getSelectedAction()->getAction()==ACTION_PRENDRE)
				setImage(curTake);
			else if (mycore->getSelectedAction()->getAction()==ACTION_ANIMATE)
				setImage(curAction);
		}
	}
	else
	{
		psCur->setPosition(mycore->cam->getPosition()+vector3df(0,-5,0));
		emCur->setDirection((mycore->cam->getTarget()-mycore->cam->getPosition())/ 10000);
		vector3df p;
		triangle3df t;
		if (mycore->getSelectedAction())
			mycore->smgr->getSceneCollisionManager()->getCollisionPoint(mycore->smgr->getSceneCollisionManager()->getRayFromScreenCoordinates(mycore->getCurPos()),mycore->getSelectedAction()->getNode()->getTriangleSelector(),p,t);
		else
			p = mycore->cam->getTarget();
		pafCur->setPoint(p);
		if (mycore->getSelectedAction())
		{
			emCur->setMinStartColor(mycore->getSelectedAction()->getColor());
			emCur->setMaxStartColor(mycore->getSelectedAction()->getColor());
		}
		else
		{
			emCur->setMinStartColor(SColor(255,255,255,255));
			emCur->setMaxStartColor(SColor(255,255,255,255));
		}
	}
	
	if ((selectedItem!=-1)&& (inv->at(selectedInv)->getItem(selectedItem).getId()!=-1))
		setImage(curTake);

	if (handle.getId()!=-1)
		setImage(handle.getTexture());
	
	if (time < mycore->getTime())
		txt->setText(L"");
	
	return 1;
}

int interface::close()
{
	log("Deleting inv");
	while (!inv->empty())
	{
		log(stringc("Deleting inventaire ") + stringc(inv->back()->getId()));
		inv->back()->close();
		inv->pop_back();
	}
	base::close();
	return 1;
}

int interface::setImage(stringc tex)
{
	image->setImage(mycore->getTexture(tex));
	return 1;
}

int interface::afficherInventaire(bool a)
{
	v=a;
	for (unsigned int i=0;i<inv->size();i++)
	{
		inv->at(i)->afficher(a);
	}
	return 1;
}

int interface::addInventaire(int i,stringc path,int v,INVENTAIRE_POS p,stringc pathvoid)
{
	inventaire* inve = new inventaire;
	rect<int> pos = rect<int>(0,0,0,0);
	switch (p)
	{
	case INVENTAIRE_POS_GAUCHE:
		pos = rect<int>(0,0,100,mycore->getDim().Height);
		break;
	case INVENTAIRE_POS_DROITE:
		pos = rect<int>(mycore->getDim().Width-100,0,mycore->getDim().Width,mycore->getDim().Height);
		break;
	case INVENTAIRE_POS_BAS:
		pos = rect<int>(0,mycore->getDim().Height-100,mycore->getDim().Width,mycore->getDim().Height);
		break;
	case INVENTAIRE_POS_HAUT:
		pos = rect<int>(0,0,mycore->getDim().Width,100);
		break;
	}
	inve->init(i,mycore,env,path,pos,v,p,pathvoid);
	inv->push_back(inve);
	log("Inventaire added");
	return 1;
}

int interface::setImagePosition(position2d<s32> pos)
{
	image->setRelativePosition(rect<s32>(pos,dimension2d<s32>(80,80)));
	return 1;
}

int interface::addItemInventaire(item m)
{
	log(stringc("Item ") + stringc(m.getId()) + " added");
	return inv->at(selectedInv)->addItem(selectedItem,m);
}


bool interface::OnEvent(const SEvent& event)
{
	if (event.EventType!=EET_MOUSE_INPUT_EVENT)
		return false;

	switch (event.MouseInput.Event)
	{
	case EMIE_LMOUSE_PRESSED_DOWN:
		if (selectedItem!=-1)
		{
			handle = inv->at(selectedInv)->getItem(selectedItem);
			inv->at(selectedInv)->removeItem(selectedItem);
			pselectedInv=selectedInv;
			pselectedItem=selectedItem;
			log(stringc("Handle item ") + stringc(handle.getId()) + " from inventaire " + stringc(selectedInv));
		}
		return true;

	case EMIE_LMOUSE_LEFT_UP:
		if (mycore->getSelectedAction())
		{
			if ( ( (handle.getId() == -1) && (mycore->getSelectedAction()->getCombi()==-1)) || (mycore->getSelectedAction()->getCombi()==handle.getId()))
			{
				if (mycore->getSelectedAction()->getAction()==ACTION_ANIMATE)
				{
					animateMesh* mesh = (animateMesh*) mycore->getSelectedAction();
					if (mycore->anim(mesh->getAnim(),mesh->getBegin(),mesh->getEnd())==1)
						log(stringc("Set animation of ") + stringc(mesh->getAnim()) + " from animMesh " + stringc(mesh->getId()));
					else
						log(stringc("Can't find actionMesh ") + stringc(mesh->getAnim()) + " for animMesh " + stringc(mesh->getId()));
				}
				else if ( (handle.getId() == -1) && (mycore->getSelectedAction()->getAction()==ACTION_PRENDRE))
				{
					selectedInv = getFreePlace();
					selectedItem = inv->at(selectedInv)->getFreePlace();
					log(stringc("Put item ") + stringc(((prendreMesh*) mycore->getSelectedAction())->getItem()) + " in default position : inventaire " + stringc(selectedInv) + " at place " + stringc(selectedItem) );
					addItemInventaire(mycore->getItem(((prendreMesh*) mycore->getSelectedAction())->getItem()));
					mycore->getSelectedAction()->getNode()->setVisible(false);
				}
			}else
			{					
				speak(mycore->getCombinaison());
			}
		}

		if (handle.getId() == -1)
			return true;

		if (selectedItem!=-1)//If an image is pointed by cursor
		{
			item it = inv->at(selectedInv)->getItem(selectedItem);
			if (it.getId()!=-1)//If there is an item in the image
			{
				if ((handle.getCombi()!=-1)&&(handle.getCombi()==it.getId()))//If the item handle combine with the item selected
				{
					mycore->play(soundFind);
					inv->at(selectedInv)->removeItem(selectedItem);
					log(stringc("Combinaison de") + stringc(handle.getId()) + " et de " + stringc(handle.getCombi()) + " qui donne : " + stringc(handle.getCombiResult()));
					addItemInventaire( mycore->getItem( handle.getCombiResult() ));
				}
				else//Sinon ils ne coresspondent pas
				{
					speak(mycore->getCombinaison());
					selectedInv=pselectedInv;
					selectedItem=pselectedItem;
					log(stringc("Put handle in previous position : inventaire ") + stringc(selectedInv) + " at place " + stringc(selectedItem) );
					addItemInventaire(handle);
				}
			}else//sinon il y en a pas
			{
				log(stringc("Put handle in inventaire ") + stringc(selectedInv) + " at place " + stringc(selectedItem) );
				addItemInventaire(handle);
			}

		}else//sinon aucune image est pointé
		{
			selectedInv=pselectedInv;
			selectedItem=pselectedItem;
			log(stringc("Put handle in previous position : inventaire ") + stringc(selectedInv) + " at place " + stringc(selectedItem) );
			addItemInventaire(handle);	
		}
		handle=item();
		return true;

	case EMIE_RMOUSE_PRESSED_DOWN:
		if (selectedItem!=-1)
		{
			speak( mycore->getObservationItem( inv->at(selectedInv)->getItem(selectedItem).getId() ) );
			log(stringc("Look item ") + stringc( inv->at(selectedInv)->getItem(selectedItem).getId())  );
		}
		else if (mycore->getSelectedAction())
		{
			if ((mycore->getSelectedAction()->getAction()==ACTION_OBSERVER)||(mycore->getSelectedAction()->getAction()==ACTION_PRENDRE)||(mycore->getSelectedAction()->getAction()==ACTION_ANIMATE))
			{
				speak( mycore->getObservationMesh( mycore->getSelectedAction()->getId() ) );
				log(stringc("Look observationMesh ") + stringc(mycore->getSelectedAction()->getId()) );
			}
		}
		return true;
	default:
		break;
	}
	return false;
}

int interface::getFreePlace()
{
	for (unsigned int i=0;i<inv->size();i++)
	{
		if ( inv->at(i)->getFreePlace() != -1 )
			return i;
	}
	return -1;
}

int interface::speak(localItem* loc)
{
	txt->setText(loc->getText().c_str());
	mycore->play(loc->getPath().c_str());
	time = mycore->getTime() + 3000;
	return 1;
}


