#include <game.h>

localItem::localItem()
{
	
}

localItem::~localItem()
{
	
}

int localItem::init(int i,stringw t,stringc p)
{
	id = i;
	text = new stringw(t);
	path = new stringc(p);
	return 1;
}
	
int localItem::getId()
{
	return id;
}


stringw localItem::getText()
{
	return *text;
}


stringc localItem::getPath()
{
	return *path;
}

//----------------------------------------------------------------------------------------------------

local::local() : base("local")
{
	observationMesh = new std::vector<localItem*>;
	observationItem = new std::vector<localItem*>;
	combinaison = new std::vector<localItem*>;
}

local::~local()
{
	delete observationMesh;
	delete observationItem;
	delete combinaison;
}

int local::init(int i,coeur* c,IXMLReader* xmlLocal)
{
	base::init(i,c);
	log(stringc("Local xml : ") + stringc(i) + " loading ...");
	while(xmlLocal && xmlLocal->read())
	{
		if (xmlLocal->getNodeType()==EXN_ELEMENT)
		{
			if (core::stringw("local") == xmlLocal->getNodeName())
			{
				observationMesh->reserve(xmlLocal->getAttributeValueAsInt(L"nbrobsm"));
				observationItem->reserve(xmlLocal->getAttributeValueAsInt(L"nbrobsi"));
				combinaison->reserve(xmlLocal->getAttributeValueAsInt(L"nbrcombi"));
			}
			else if (core::stringw("observationMesh") == xmlLocal->getNodeName())
			{
				addObservationMesh(xmlLocal->getAttributeValueAsInt(L"id"),xmlLocal->getAttributeValue(L"text"),xmlLocal->getAttributeValue(L"file"));
				log( stringc("New observationMesh text : id:") + xmlLocal->getAttributeValue(L"id") + ", text: " + xmlLocal->getAttributeValue(L"text") + ", sound file: " + xmlLocal->getAttributeValue(L"file"));
			}
			else if (core::stringw("observationItem") == xmlLocal->getNodeName())
			{
				addObservationItem(xmlLocal->getAttributeValueAsInt(L"id"),xmlLocal->getAttributeValue(L"text"),xmlLocal->getAttributeValue(L"file"));
				log( stringc("New observationItem text : id:") + xmlLocal->getAttributeValue(L"id") + ", text: " + xmlLocal->getAttributeValue(L"text") + ", sound file: " + xmlLocal->getAttributeValue(L"file"));
			}
			else if (core::stringw("combinaison") == xmlLocal->getNodeName())
			{
				addCombinaison(xmlLocal->getAttributeValueAsInt(L"id"),xmlLocal->getAttributeValue(L"text"),xmlLocal->getAttributeValue(L"file"));
				log( stringc("New combinaisonItem text : id:") + xmlLocal->getAttributeValue(L"id") + ", text: " + xmlLocal->getAttributeValue(L"text") + ", sound file: " + xmlLocal->getAttributeValue(L"file"));
			}
			else if (core::stringw("caption") == xmlLocal->getNodeName())
			{
				caption = xmlLocal->getAttributeValue(L"text");
				log( stringc("New caption text : ") + xmlLocal->getAttributeValue(L"text"));
			}
		}
	}


	return 1;
}

int local::update()
{
	return 1;
}

int local::close()
{
	log("Closing each observationMesh text");
	while (!observationMesh->empty())
	{
		log(stringc("Deleting observationMesh text") + stringc(observationMesh->back()->getId()));
		delete observationMesh->back();
		observationMesh->pop_back();
	}
	log("Closing each observationItem text");
	while (!observationItem->empty())
	{
		log(stringc("Deleting observationItem text") + stringc(observationItem->back()->getId()));
		delete observationItem->back();
		observationItem->pop_back();
	}
	log("Closing each combinaison text");
	while (!combinaison->empty())
	{
		log(stringc("Deleting combinaison text") + stringc(combinaison->back()->getId()));
		delete combinaison->back();
		combinaison->pop_back();
	}
	base::close();
	return 1;
}

int local::addObservationMesh(int id,stringw text,stringc path)
{
	localItem* l = new localItem();
	l->init(id,text,path);
	observationMesh->push_back(l);
	log("observationMesh text added");
	return 1;
}

int local::addObservationItem(int id,stringw text,stringc path)
{
	localItem* l = new localItem();
	l->init(id,text,path);
	observationItem->push_back(l);
	log("observationItem text added");
	return 1;
}

int local::addCombinaison(int id,stringw text,stringc path)
{
	localItem* l = new localItem();
	l->init(id,text,path);
	combinaison->push_back(l);
	log("combinaison text added");
	return 1;
}

localItem* local::getCombinaison()
{
	return (*combinaison)[rand()%combinaison->size()];
}

stringw local::getCaption()
{
	return caption;
}

bool local::OnEvent(const SEvent& event)
{
	return false;
}

localItem* local::getObservationMesh(int id)
{
	for (unsigned int i=0;i<observationMesh->size();i++)
		if (observationMesh->at(i)->getId() == id)
		{
			return (*observationMesh)[i];
		}
	return 0;
}

localItem* local::getObservationItem(int id)
{
	for (unsigned int i=0;i<observationItem->size();i++)
		if (observationItem->at(i)->getId() == id)
		{
			return observationItem->at(i);
		}
	return 0;
}

